Index: /branches/network/src/lib/graphics/graphics_engine.cc
===================================================================
--- /branches/network/src/lib/graphics/graphics_engine.cc	(revision 6510)
+++ /branches/network/src/lib/graphics/graphics_engine.cc	(revision 6511)
@@ -270,5 +270,5 @@
     this->hwExtensions = new SubString((char*)glGetString(GL_EXTENSIONS), " \n\t,");
 
-  PRINT(4)("Running on : %s %s %s\n", vendor, renderer, version);
+  PRINT(4)("Running on : vendor: %s,  renderer: %s,  version:%s\n", vendor, renderer, version);
   PRINT(4)("Extensions:\n");
   if (this->hwExtensions != NULL)
Index: /branches/network/src/lib/graphics/importer/texture.cc
===================================================================
--- /branches/network/src/lib/graphics/importer/texture.cc	(revision 6510)
+++ /branches/network/src/lib/graphics/importer/texture.cc	(revision 6511)
@@ -260,15 +260,16 @@
   glBindTexture(target, texture);
 
-  glTexParameteri(target, GL_TEXTURE_MIN_FILTER, GL_LINEAR_MIPMAP_LINEAR);
+  glTexParameteri(target, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
+  glTexParameteri(target, GL_TEXTURE_WRAP_R, GL_CLAMP_TO_EDGE);
+
+  glTexParameteri(target, GL_TEXTURE_MIN_FILTER, GL_LINEAR/*_MIPMAP_LINEAR*/);
   glTexParameteri(target, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
 
-
-  glTexParameteri(target, GL_TEXTURE_WRAP_S, GL_REPEAT);
-  glTexParameteri(target, GL_TEXTURE_WRAP_T, GL_REPEAT);
+  glTexParameterf(GL_TEXTURE_ENV, GL_TEXTURE_PRIORITY, this->priority);
+
 
   /* control the mipmap levels */
-//   glTexParameterf(GL_TEXTURE_ENV, GL_TEXTURE_MIN_LOD, 5);f
-//   glTexParameterf(GL_TEXTURE_ENV, GL_TEXTURE_MAX_LOD, 0);
-  glTexParameterf(GL_TEXTURE_ENV, GL_TEXTURE_PRIORITY, this->priority);
+  glTexParameterf(GL_TEXTURE_ENV, GL_TEXTURE_MIN_LOD, 5);
+  glTexParameterf(GL_TEXTURE_ENV, GL_TEXTURE_MAX_LOD, 0);
 
   /* build the Texture  OpenGL V >= 1.1 */
@@ -294,5 +295,5 @@
     PRINTF(1)("Error while loading texture (mipmap generation), gluBuild2DMipmaps returned %i\n", errorCode);
 
-  glBindTexture(target, 0);
+
   return texture;
 }
Index: /branches/network/src/world_entities/skybox.cc
===================================================================
--- /branches/network/src/world_entities/skybox.cc	(revision 6510)
+++ /branches/network/src/world_entities/skybox.cc	(revision 6511)
@@ -72,4 +72,5 @@
   this->toList(OM_ENVIRON_NOTICK);
   this->size = 100.0;
+  this->textureSize = 1024.0f;
 
   for (int i = 0; i < 6; i++)
@@ -205,4 +206,17 @@
 }
 
+
+
+void SkyBox::draw()
+{
+  glPushAttrib(GL_LIGHTING_BIT);
+  glDisable(GL_LIGHTING);
+  WorldEntity::draw();
+//   glEnable(GL_LIGHTING);
+  glPopAttrib();
+
+}
+
+
 /**
  *  rebuilds the SkyBox
@@ -223,8 +237,14 @@
   model->addVertex (0.5*size, -0.5*size, -0.5*size);
 
-  model->addVertexTexture (0.0, 1.0);
-  model->addVertexTexture (1.0, 1.0);
-  model->addVertexTexture (1.0, 0.0);
-  model->addVertexTexture (0.0, 0.0);
+//   model->addVertexTexture (0.0, 1.0);
+//   model->addVertexTexture (1.0, 1.0);
+//   model->addVertexTexture (1.0, 0.0);
+//   model->addVertexTexture (0.0, 0.0);
+
+  model->addVertexTexture (1.0/this->textureSize, (this->textureSize - 1.0)/this->textureSize);
+  model->addVertexTexture ((this->textureSize - 1.0)/this->textureSize, (this->textureSize - 1.0)/this->textureSize);
+  model->addVertexTexture ((this->textureSize - 1.0)/this->textureSize, 1.0/this->textureSize);
+  model->addVertexTexture (1.0/this->textureSize, 1.0/this->textureSize);
+
 
   model->addVertexNormal (0.0, 0.0, 1.0);
Index: /branches/network/src/world_entities/skybox.h
===================================================================
--- /branches/network/src/world_entities/skybox.h	(revision 6510)
+++ /branches/network/src/world_entities/skybox.h	(revision 6511)
@@ -33,4 +33,5 @@
   void postInit();
 
+  virtual void draw();
 
   void setSize(float size);
@@ -60,4 +61,5 @@
 
   float           size;            //!< Size of the SkyBox. This should match the frustum maximum range.
+  float           textureSize;     //!< this is the length of a texture (assumes a square texture)
   char*           textureName;     //!< Name of the Texture
 